DL_EncryptorImpl< SCHEME_OPTIONS > Class Template Reference

_ More...

`#include <pubkey.h>`

Inheritance diagram for DL_EncryptorImpl< SCHEME_OPTIONS >:

## Public Types

typedef SCHEME_OPTIONS::PublicKey::Element | Element
typedef SCHEME_OPTIONS | SchemeOptions

## Public Member Functions

PrivateKey & | AccessPrivateKey ()
PublicKey & | AccessPublicKey ()
const SCHEME_OPTIONS::PublicKey & | GetKey () const
SCHEME_OPTIONS::PublicKey & | AccessKey ()
std::string | AlgorithmName () const
void | Encrypt (RandomNumberGenerator &rng, const byte *plaintext, size_t plaintextLength, byte *ciphertext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| encrypt a byte string More...
size_t | MaxPlaintextLength (size_t ciphertextLength) const
size_t | CiphertextLength (size_t plaintextLength) const
bool | ParameterSupported (const char *name) const
virtual BufferedTransformation * | CreateEncryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new encryption filter More...
virtual size_t | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0 More...
virtual size_t | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual const PublicKey & | GetPublicKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Static Public Member Functions

static std::string | StaticAlgorithmName ()

## Protected Types

typedef DL_PublicKey< SCHEME_OPTIONS::Element > | KeyInterface

## Protected Member Functions

const DL_ElgamalLikeSignatureAlgorithm< Element > & | GetSignatureAlgorithm () const
const DL_KeyAgreementAlgorithm< Element > & | GetKeyAgreementAlgorithm () const
const DL_KeyDerivationAlgorithm< Element > & | GetKeyDerivationAlgorithm () const
const DL_SymmetricEncryptionAlgorithm & | GetSymmetricEncryptionAlgorithm () const
HashIdentifier | GetHashIdentifier () const
const PK_SignatureMessageEncodingMethod & | GetMessageEncodingInterface () const
DL_EncryptorBase< SCHEME_OPTIONS::Element >::KeyInterface & | AccessKeyInterface ()
const DL_EncryptorBase< SCHEME_OPTIONS::Element >::KeyInterface & | GetKeyInterface () const
size_t | GetDigestSize () const
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()

## Detailed Description

### template<class SCHEME_OPTIONS>
class DL_EncryptorImpl< SCHEME_OPTIONS >

_

Definition at line 1362 of file pubkey.h.

## Member Function Documentation

void DL_EncryptorBase< SCHEME_OPTIONS::Element >::Encrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | plaintext,
|  | size_t | plaintextLength,
|  | byte * | ciphertext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

inline virtual inherited

encrypt a byte string

Precondition
  CiphertextLength(plaintextLength) != 0 (i.e., plaintext isn't too long)
  size of ciphertext == CiphertextLength(plaintextLength)

Implements PK_Encryptor.

Definition at line 1220 of file pubkey.h.

References Integer::One().

virtual BufferedTransformation* PK_Encryptor::CreateEncryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

virtual inherited

create a new encryption filter

Note
  The caller is responsible for deleting the returned pointer.
  Encoding parameters should be passed in the "EP" channel.

virtual size_t PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const

inline virtual inherited

return fixed ciphertext length, if one exists, otherwise return 0

Note
  "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length.

Definition at line 1211 of file cryptlib.h.

The documentation for this class was generated from the following file:

- pubkey.h